/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.mappers.VectorFieldDisplacement;

import org.visnow.jscic.dataarrays.DataArray;
import org.visnow.jscic.Field;
import org.visnow.vn.geometries.viewer3d.eventslisteners.render.FrameModificationEvent;
import org.visnow.vn.geometries.viewer3d.eventslisteners.render.FrameModificationListener;
import org.visnow.vn.geometries.viewer3d.eventslisteners.render.FrameRenderedListener;
import static org.apache.commons.math3.util.FastMath.*;

public class GUI extends javax.swing.JPanel
{

    protected Params params = null;
    protected Field field = null;
    protected float low = 0;
    protected float up = 1;

    ;

    /** Creates new form EmptyVisnowModuleGUI */
    public GUI()
    {
        initComponents();
        vectorComponentSelector.setTitle("vector component");
        vectorComponentSelector.setVectorComponentsOnly(true);
        animationPanel.setNFrames(200);
        animationPanel.setLabels("scale range", "scale");
        animationPanel.addListener(new FrameModificationListener()
        {
            @Override
            public void frameChanged(FrameModificationEvent e)
            {
                params.setAdjusting(animationPanel.isAdjusting());
                params.setScale(animationPanel.getCurrentTime());
            }
        });
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        vectorComponentSelector = new org.visnow.vn.lib.gui.DataComponentSelector();
        jPanel1 = new javax.swing.JPanel();
        animationPanel = new org.visnow.vn.lib.gui.AnimationPanel();

        setLayout(new java.awt.GridBagLayout());

        vectorComponentSelector.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                vectorComponentSelectorStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(vectorComponentSelector, gridBagConstraints);

        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel1.setLayout(new java.awt.BorderLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        add(jPanel1, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(animationPanel, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void vectorComponentSelectorStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_vectorComponentSelectorStateChanged
    {//GEN-HEADEREND:event_vectorComponentSelectorStateChanged
        if (params != null) {
            params.setVectorComponent(vectorComponentSelector.getComponent());
            recomputeScaleRange();
        }
    }//GEN-LAST:event_vectorComponentSelectorStateChanged

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private org.visnow.vn.lib.gui.AnimationPanel animationPanel;
    private javax.swing.JPanel jPanel1;
    private org.visnow.vn.lib.gui.DataComponentSelector vectorComponentSelector;

    // End of variables declaration//GEN-END:variables
    private void recomputeScaleRange()
    {
        if (field == null)
            return;
        int selComp = vectorComponentSelector.getComponent();
        if (field.getComponent(selComp) == null)
            return;
        DataArray va = field.getComponent(selComp);
        float[][] ext = field.getPreferredExtents();
        double r = 0, vr = 0;
        for (int i = 0; i < 3; i++) {
            r += (ext[1][i] - ext[0][i]) * (ext[1][i] - ext[0][i]);
            vr += va.getPreferredMaxValue() * va.getPreferredMaxValue();
        }
        vr = sqrt(vr);
        r = sqrt(r);
        if (vr == 0)
            vr = .1e-6;
        int n = (int) (999.9 + log10(r / vr)) - 1000;
        float maxv = (float) pow(10, n);
        animationPanel.setTimeRange(-maxv, maxv);
        animationPanel.setFrame(0, false);
        params.setScale(0);
    }

    public void setParams(Params params)
    {
        this.params = params;
    }

    public void setInData(Field field)
    {
        this.field = field;
        vectorComponentSelector.setDataSchema(field.getSchema());
        recomputeScaleRange();
    }

    public FrameRenderedListener getFrameRenderedListener()
    {
        return animationPanel.getFrameRenderedListener();
    }

}
